package com.argotec.siar.util;

import java.time.LocalDate;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;

import static com.argotec.scraper.ScraperUtil.normalizeString;

public class FormatUtil {

    public static float toFloat(String stringFloat) {
        return Float.valueOf(stringFloat.replace(",", "."));
    }

    public static LocalDate toDate(String stringDate) {
        return LocalDate.parse(stringDate, DateTimeFormatter.ofPattern("dd/MM/yyyy"));
    }

    public static LocalTime toTime(String stringTime) {
        return LocalTime.parse(stringTime, DateTimeFormatter.ofPattern("HH:mm"));
    }

    public static boolean stringsAreEqualAfterNormalization(String string1, String string2) {
        return normalizeString(string1).equals(normalizeString(string2));
    }
}
