package com.argotec.restapi;

import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.http.HttpMethod;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.request.MockHttpServletRequestBuilder;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.web.client.RestTemplate;

import static org.springframework.boot.test.context.SpringBootTest.WebEnvironment.RANDOM_PORT;

@RunWith(SpringRunner.class)
@SpringBootTest(webEnvironment = RANDOM_PORT)
@AutoConfigureMockMvc
public class IntegrationTestScaffolding {

    private RestTemplate restTemplate = new RestTemplate();

    @Autowired
    protected MockMvc mockMvc;

    @LocalServerPort
    private int port;

    private static final String URL = "http://localhost";

    protected MockHttpServletRequestBuilder get(String restEndpoint, Object... uriVars) {
        return MockMvcRequestBuilders.request(HttpMethod.GET, url(restEndpoint), uriVars);
    }

    private String url(String resourcePath) {
        return String.format("%s:%s%s", URL, port, resourcePath);
    }
}
